const defaultState = {
  movies: [],
  selectedMovie: {
    index: 0,
    fetchingDetails: false,
  },
};

export default function movieStore(state = defaultState, action) {
  switch (action.type) {
    case 'MOVIE_LIST_FETCH_FULFILLED':
      return Object.assign({}, state, {
        movies: action.payload.data,
      })
    case 'MOVIE_GET_DETAILS_PENDING':
      return Object.assign({}, state, {
        selectedMovie: Object.assign({}, state.selectedMovie, {
          fetchingDetails: true,
        }),
      })
    case 'MOVIE_GET_DETAILS_FULFILLED':
      let movies = state.movies.slice();
      movies[state.selectedMovie.index] = action.payload.data;
      return Object.assign({}, state, {
        movies: movies,
        selectedMovie: Object.assign({}, state.selectedMovie, {
          fetchingDetails: false,
        }),
      })
    case 'SELECT_MOVIE':
      // Don't select the movie if we're fetching another movie's details
      if (state.selectedMovie.fetchingDetails) {
        return state
      }

      return Object.assign({}, state, {
        selectedMovie: Object.assign({}, state.selectedMovie, {
          index: action.index,
        }),
      })
    default:
      return state
  }
}
